/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.modules.guosen.bonusgroupaccount.controller;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.qiniu.util.Auth;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import lombok.AllArgsConstructor;
import javax.validation.Valid;

import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.secure.BladeUser;
import org.springblade.core.secure.utils.AuthUtil;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.core.tool.utils.StringUtil;
import org.springblade.modules.guosen.bonusgroupaccount.vo.SimpleBonusGroupAccountVO;
import org.springblade.modules.guosen.bonusgroupstrategy.entity.BonusGroupStrategy;
import org.springblade.modules.guosen.bonusgroupstrategy.vo.SimpleBonusGroupStrategyVO;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.modules.guosen.bonusgroupaccount.entity.BonusGroupAccount;
import org.springblade.modules.guosen.bonusgroupaccount.vo.BonusGroupAccountVO;
import org.springblade.modules.guosen.bonusgroupaccount.wrapper.BonusGroupAccountWrapper;
import org.springblade.modules.guosen.bonusgroupaccount.service.IBonusGroupAccountService;
import org.springblade.core.boot.ctrl.BladeController;

import java.util.List;
import java.util.stream.Collectors;

/**
 * 分润组收款账号 控制器
 *
 * @author BladeX
 * @since 2021-11-13
 */
@RestController
@AllArgsConstructor
@RequestMapping("cyzh-bonus-group-account/bonusgroupaccount")
@Api(value = "分润组收款账号", tags = "分润组收款账号接口")
public class BonusGroupAccountController extends BladeController {

	private final IBonusGroupAccountService bonusGroupAccountService;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入bonusGroupAccount")
	public R<BonusGroupAccountVO> detail(BonusGroupAccount bonusGroupAccount) {
		BonusGroupAccount detail = bonusGroupAccountService.getOne(Condition.getQueryWrapper(bonusGroupAccount));
		return R.data(BonusGroupAccountWrapper.build().entityVO(detail));
	}

	/**
	 * 分页 分润组收款账号
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入bonusGroupAccount")
	public R<IPage<BonusGroupAccountVO>> list(BonusGroupAccount bonusGroupAccount, Query query) {
		IPage<BonusGroupAccount> pages = bonusGroupAccountService.page(Condition.getPage(query), Condition.getQueryWrapper(bonusGroupAccount));
		return R.data(BonusGroupAccountWrapper.build().pageVO(pages));
	}


	/**
	 * 自定义分页 分润组收款账号
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入bonusGroupAccount")
	public R<IPage<BonusGroupAccountVO>> page(BonusGroupAccountVO bonusGroupAccount, Query query) {
		IPage<BonusGroupAccountVO> pages = bonusGroupAccountService.selectBonusGroupAccountPage(Condition.getPage(query), bonusGroupAccount);
		return R.data(pages);
	}

	/**
	 * 新增 分润组收款账号
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入bonusGroupAccount")
	public R save(@Valid @RequestBody BonusGroupAccount bonusGroupAccount) {
		return R.status(bonusGroupAccountService.save(bonusGroupAccount));
	}

	/**
	 * 修改 分润组收款账号
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入bonusGroupAccount")
	public R update(@Valid @RequestBody BonusGroupAccount bonusGroupAccount) {
		return R.status(bonusGroupAccountService.updateById(bonusGroupAccount));
	}

	/**
	 * 新增或修改 分润组收款账号
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入bonusGroupAccount")
	public R submit(@Valid @RequestBody BonusGroupAccount bonusGroupAccount) {
		BladeUser bladeUser = AuthUtil.getUser();
		if(bladeUser.getRoleName().equals("财务管理") || bladeUser.getRoleName().equals("administrator")){//运营查询平台商余额
			return R.status(bonusGroupAccountService.saveOrUpdate(bonusGroupAccount));
		}else{
			return R.fail("无权限操作");
		}

	}

	
	/**
	 * 删除 分润组收款账号
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(bonusGroupAccountService.deleteLogic(Func.toLongList(ids)));
	}

	/**
	 * 根据条件下拉获取分润账户list
	 * @param account
	 * @return
	 */
	@GetMapping(value = "/listBonusGroupAccount")
	@ApiOperationSupport(order = 8)
	public R<List<SimpleBonusGroupAccountVO>> listBonusScene(BonusGroupAccount account){
		LambdaQueryWrapper<BonusGroupAccount> lambdaQueryWrapper = new LambdaQueryWrapper<>();
		if(StringUtil.isNotBlank(account.getAccountReceiverName())){
			lambdaQueryWrapper.like(BonusGroupAccount::getAccountReceiverName, account.getAccountReceiverName());
		}
		if(account.getBonusSceneId() != null){
			lambdaQueryWrapper.eq(BonusGroupAccount::getBonusSceneId, account.getBonusSceneId());
		}
		if(account.getBonusGroupId() != null){
			lambdaQueryWrapper.eq(BonusGroupAccount::getBonusGroupId, account.getBonusGroupId());
		}
		lambdaQueryWrapper.or().eq(BonusGroupAccount::getIsDefault, 1);
		List<BonusGroupAccount> list = this.bonusGroupAccountService.list(lambdaQueryWrapper);
		List<SimpleBonusGroupAccountVO> voList = list.stream()
						.map(item -> {
							SimpleBonusGroupAccountVO vo = new SimpleBonusGroupAccountVO();
							vo.setId(item.getId());
							vo.setName(item.getAccountReceiverName());
							vo.setIsDefault(item.getIsDefault());
							return vo;
						}).collect(Collectors.toList());
		return R.data(voList);
	}

	
}
